package com.zd.exam.service;

import com.zd.exam.domain.ElQu;

import java.util.List;
import java.util.Map;

/**
 * 问题题目(ElQu)表服务接口
 *
 * @author liubo
 * @since 2021-08-30 15:26:29
 */
public interface ElQuService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    ElQu queryById(Long id);

    /**
     * 查询多条数据
     *
     * @param offset 查询起始位置
     * @param limit  查询条数
     * @return 对象列表
     */
    List<ElQu> queryAllByLimit(int offset, int limit);

    /**
     * 新增数据
     *
     * @param elQu 实例对象
     * @return 实例对象
     */
    int insert(ElQu elQu);

    /**
     * 修改数据
     *
     * @param elQu 实例对象
     * @return 实例对象
     */
    int update(ElQu elQu);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Long id);

    int deleteByIds(List<Long> ids);

    List<ElQu> queryList(ElQu qu);

    List<ElQu> selectElQuList(ElQu elQu);

    String importData(List<ElQu> quList);

    /**
     * 随机抽取题库的数据
     *
     * @param classifyId
     * @param quType
     * @param level    难度等级 1中等,2较难,3难
     * @param excludes 要排除的ID列表
     * @param size
     */
//    List<ElQu> listByRandom(Long classifyId, Long repoId, Integer quType, Integer level, List<Long> excludes, Integer size);
    List<ElQu> listByRandom(Long classifyId, Integer quType, Integer level, List<Long> excludes, Integer size);

    /**
     * 随机抽取题库的数据
     *
     * @param repoId
     * @param quType
     * @param level    难度等级 1中等,2较难,3难
     * @param excludes 要排除的ID列表
     * @param size
     */
    List<ElQu> otherListByRandom(Long repoId, Integer quType, Integer level, List<Long> excludes, Integer size);

    List<ElQu> queryByIds(List<Long> quIds);

    Map<String, Integer> selectQuCountByClassifyIds(List<Long> classifyIds);
}
